import static com.kms.katalon.core.checkpoint.CheckpointFactory.findCheckpoint
import static com.kms.katalon.core.testcase.TestCaseFactory.findTestCase
import static com.kms.katalon.core.testdata.TestDataFactory.findTestData
import static com.kms.katalon.core.testobject.ObjectRepository.findTestObject
import com.kms.katalon.core.checkpoint.Checkpoint as Checkpoint
import com.kms.katalon.core.cucumber.keyword.CucumberBuiltinKeywords as CucumberKW
import com.kms.katalon.core.mobile.keyword.MobileBuiltInKeywords as Mobile
import com.kms.katalon.core.model.FailureHandling as FailureHandling
import com.kms.katalon.core.testcase.TestCase as TestCase
import com.kms.katalon.core.testdata.TestData as TestData
import com.kms.katalon.core.testobject.TestObject as TestObject
import com.kms.katalon.core.webservice.keyword.WSBuiltInKeywords as WS
import com.kms.katalon.core.webui.keyword.WebUiBuiltInKeywords as WebUI
import internal.GlobalVariable as GlobalVariable

// Define attribute values for client account
def password = 'cropmetrics'
def email = 'cropmetricsvo.client@gmail.com'
def fullname = 'test validation'
def phone = '123'
def dealer = 'x'
def addressLine1 = 'address line 1 test validation'
def addressLine2 = 'address line 2 test validation'
def town = 'townValidation'
def state = 'stateValidation'
def zip = 'xx'
def country = 'xx'
def roles = 'Client'

// Get token
def tokenUserName = 'admin'
def tokenPassword = 'cropmetricsvo'

responseToken = WS.sendRequest(findTestObject('VoPro/Token', [('usernameToken') : tokenUserName, ('passwordToken') : tokenPassword]))

// Get responseToken body response attributes
def slurper = new groovy.json.JsonSlurper()
def tokenResult = slurper.parseText(responseToken.getResponseBodyContent())

// Get result parameters of token
def accessToken = tokenResult.access_token

println('.. Current access token generated for admin user : ' + accessToken)

// Post new account 
responseAdminRegister = WS.sendRequest(findTestObject('VoPro/Account/api_admin_v1_users', [('access_token') : accessToken, ('password') : password, ('email') : email
	, ('fullname') : fullname, ('phone') : phone, ('dealer') : dealer, ('addressLine1') : addressLine1, ('addressLine2') : addressLine2, ('town') : town
	, ('state') : state, ('zip') : zip, ('country') : country, ('roles') : roles]))


// Define attribute values the new account trying to create this by the previous client created
def passwordByClient = 'cropmetrics'
def emailByClient = 'cropmetricsvo.clientbyclient@gmail.com'
def fullnameByClient = 'test validation'
def phoneByClient = '123'
def dealerByClient = 'x'
def addressLine1ByClient = 'address line 1 test validation'
def addressLine2ByClient = 'address line 2 test validation'
def townByClient = 'townValidation'
def stateByClient = 'stateValidation'
def zipByClient = 'xx'
def countryByClient = 'xx'
def rolesByClient = 'Client'

// Get token
responseTokenByClient = WS.sendRequest(findTestObject('VoPro/Token', [('usernameToken') : email, ('passwordToken') : password]))

// Get responseToken body response attributes
def slurperByClient = new groovy.json.JsonSlurper()
def tokenResultByClient = slurperByClient.parseText(responseTokenByClient.getResponseBodyContent())

// Get result parameters of token client account
def accessTokenByClient = tokenResultByClient.access_token

println('.. Current access token generated by the new client account : ' + accessTokenByClient)

// Post new account 
responseAdminRegisterByClient = WS.sendRequest(findTestObject('VoPro/Account/api_admin_v1_users', [('access_token') : accessTokenByClient, ('password') : passwordByClient, ('email') : emailByClient
	, ('fullname') : fullnameByClient, ('phone') : phoneByClient, ('dealer') : dealerByClient, ('addressLine1') : addressLine1ByClient, ('addressLine2') : addressLine2ByClient, ('town') : townByClient
	, ('state') : stateByClient, ('zip') : zipByClient, ('country') : countryByClient, ('roles') : rolesByClient]))


WS.verifyResponseStatusCode(responseAdminRegisterByClient, 401)

// Get response message for AdminRegister endpoint
def slurper1 = new groovy.json.JsonSlurper()
def AdminRegisterResult = slurper1.parseText(responseAdminRegisterByClient.getResponseBodyContent())
def messageResponse = AdminRegisterResult.message
def messageExpected = "Authorization has been denied for this request."

//Print message response
println('Error message response: ' + messageResponse)
println('Error message expected: ' + messageExpected)

WS.verifyElementPropertyValue(responseAdminRegisterByClient, 'message', messageExpected)
